unit XFormAutoSize;

interface

uses Windows, XClasses, XVisuals, XWindows, XForms, XApplets;

type XFormAutoSizer = class
     private
        //fOnAutoSize : XOnEvent;
     protected
     public
        constructor Create;
        //property OnAutoSizeForm : XOnEvent read fOnAutoSize write fOnAutoSize;
        procedure Execute( Sender : TObject );
     end;

procedure UseFormAutoSize;

var FormAutoSizer : XFormAutoSizer;

implementation

procedure UseFormAutoSize;
begin
   if FormAutoSizer = nil then
      FormAutoSizer := XFormAutoSizer.Create;
end;

constructor XFormAutoSizer.Create;
begin
   inherited;
   GlobalFormsManager.On_AutoSizeForm := Execute;
end;

procedure XFormAutoSizer.Execute( Sender : TObject );
var V : XVisual;
    I, W, H, W1, H1, M : Integer;
    E : XControl;
    R : TRect;
begin
   W := 0; H := 0;
   V := Sender as XVisual;
   if V is XForm then
   begin
      if not (V as XForm).AutoSize then Exit;
      W := 64; H := 32;
   end;
   if V.ChildsCount > 0 then
   begin
      for I := 0 to V.ChildsCount - 1 do
      begin
         if V.Childs[ I ] is XControl then
         begin
            E := V.Childs[ I ] as XControl;
            if not E.Visible then continue;
            Execute( E );
            M := E.ParentForm.Margin;
            if E.Align <> alNone then M := 0;
            W1 := E.Left + E.Width + M;
            if W1 > W then W := W1;
            H1 := E.Top + E.Height + M;
            if H1 > H then H := H1;
         end;
      end;
      R := V.ClientRect;
      if (R.Right - R.Left < W) or (R.Bottom - R.Top < H) then
      begin
         W := W + V.Width - (R.Right - R.Left);
         H := H + V.Height - (R.Bottom - R.Top);
         R := V.BoundsRect;
         R.Right := R.Left + W;
         R.Bottom := R.Top + H;
         V.BoundsRect := R;
         if Sender is XForm then
         //if Assigned( fOnAutoSize ) then
         //   fOnAutoSize( Sender );
      end;
   end;
   //if Assigned( fOnAutoSize ) then
   //   fOnAutoSize( Sender );
end;

end.
